/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         aalogparse_parse
#define yylex           aalogparse_lex
#define yyerror         aalogparse_error
#define yydebug         aalogparse_debug
#define yynerrs         aalogparse_nerrs


/* Copy the first part of user declarations.  */
#line 19 "grammar.y" /* yacc.c:339  */


/* set the following to non-zero to get bison to emit debugging
 * information about tokens given and rules matched.
 * Also:
 *   Uncomment the %defines
 *   parse.error
 *   parse.trace
 */
#define YYDEBUG 0
#include <string.h>
#include <aalogparse.h>
#include "parser.h"
#include "grammar.h"
#include "scanner.h"

#ifndef unused_
#define unused_ __attribute__ ((unused))
#endif
#if (YYDEBUG != 0)
#define debug_unused_ /* nothing */
#else
#define debug_unused_ unused_
#endif

aa_log_record *ret_record;

/* Since we're a library, on any errors we don't want to print out any
 * error messages. We should probably add a debug interface that does
 * emit messages when asked for. */
void aalogparse_error(unused_ void *scanner, debug_unused_ char const *s)
{
#if (YYDEBUG != 0)
	printf("ERROR: %s\n", s);
#endif
	ret_record->event = AA_RECORD_INVALID;
}

struct aa_type_table {
	unsigned int audit_type;
	aa_record_event_type event;
};

static struct aa_type_table aa_type_table[] = {
	{AUDIT_APPARMOR_AUDIT,   AA_RECORD_AUDIT},
	{AUDIT_APPARMOR_ALLOWED, AA_RECORD_ALLOWED},
	{AUDIT_APPARMOR_DENIED,  AA_RECORD_DENIED},
	{AUDIT_APPARMOR_HINT,    AA_RECORD_HINT},
	{AUDIT_APPARMOR_STATUS,  AA_RECORD_STATUS},
	{AUDIT_APPARMOR_ERROR,   AA_RECORD_ERROR},
	{0,                      AA_RECORD_INVALID},
};

aa_record_event_type lookup_aa_event(unsigned int type)
{
	int i;

	for (i = 0; aa_type_table[i].audit_type != 0; i++)
		if (type == aa_type_table[i].audit_type)
			break;

	return aa_type_table[i].event;
}



#line 139 "grammar.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_AALOGPARSE_GRAMMAR_H_INCLUDED
# define YY_AALOGPARSE_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int aalogparse_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_DIGITS = 258,
    TOK_TYPE_UNKNOWN = 259,
    TOK_QUOTED_STRING = 260,
    TOK_ID = 261,
    TOK_MODE = 262,
    TOK_DMESG_STAMP = 263,
    TOK_AUDIT_DIGITS = 264,
    TOK_DATE_MONTH = 265,
    TOK_DATE = 266,
    TOK_TIME = 267,
    TOK_HEXSTRING = 268,
    TOK_TYPE_OTHER = 269,
    TOK_MSG_REST = 270,
    TOK_IP_ADDR = 271,
    TOK_EQUALS = 272,
    TOK_COLON = 273,
    TOK_MINUS = 274,
    TOK_OPEN_PAREN = 275,
    TOK_CLOSE_PAREN = 276,
    TOK_PERIOD = 277,
    TOK_QUESTION_MARK = 278,
    TOK_SINGLE_QUOTE = 279,
    TOK_TYPE_REJECT = 280,
    TOK_TYPE_AUDIT = 281,
    TOK_TYPE_COMPLAIN = 282,
    TOK_TYPE_HINT = 283,
    TOK_TYPE_STATUS = 284,
    TOK_TYPE_ERROR = 285,
    TOK_TYPE_AA_REJECT = 286,
    TOK_TYPE_AA_AUDIT = 287,
    TOK_TYPE_AA_COMPLAIN = 288,
    TOK_TYPE_AA_HINT = 289,
    TOK_TYPE_AA_STATUS = 290,
    TOK_TYPE_AA_ERROR = 291,
    TOK_TYPE_LSM_AVC = 292,
    TOK_TYPE_USER_AVC = 293,
    TOK_KEY_APPARMOR = 294,
    TOK_KEY_TYPE = 295,
    TOK_KEY_MSG = 296,
    TOK_KEY_OPERATION = 297,
    TOK_KEY_NAME = 298,
    TOK_KEY_NAME2 = 299,
    TOK_KEY_MASK = 300,
    TOK_KEY_DENIED_MASK = 301,
    TOK_KEY_REQUESTED_MASK = 302,
    TOK_KEY_ATTRIBUTE = 303,
    TOK_KEY_TASK = 304,
    TOK_KEY_PARENT = 305,
    TOK_KEY_MAGIC_TOKEN = 306,
    TOK_KEY_INFO = 307,
    TOK_KEY_PEER_INFO = 308,
    TOK_KEY_PID = 309,
    TOK_KEY_PEER_PID = 310,
    TOK_KEY_PROFILE = 311,
    TOK_KEY_PEER_PROFILE = 312,
    TOK_KEY_LABEL = 313,
    TOK_KEY_PEER_LABEL = 314,
    TOK_KEY_PEER = 315,
    TOK_AUDIT = 316,
    TOK_KEY_FAMILY = 317,
    TOK_KEY_SOCK_TYPE = 318,
    TOK_KEY_PROTOCOL = 319,
    TOK_KEY_NAMESPACE = 320,
    TOK_KEY_ERROR = 321,
    TOK_KEY_FSUID = 322,
    TOK_KEY_FSUID_UPPER = 323,
    TOK_KEY_OUID = 324,
    TOK_KEY_OUID_UPPER = 325,
    TOK_KEY_UID = 326,
    TOK_KEY_AUID = 327,
    TOK_KEY_SAUID = 328,
    TOK_KEY_SES = 329,
    TOK_KEY_HOSTNAME = 330,
    TOK_KEY_ADDR = 331,
    TOK_KEY_TERMINAL = 332,
    TOK_KEY_EXE = 333,
    TOK_KEY_COMM = 334,
    TOK_KEY_CAPABILITY = 335,
    TOK_KEY_CAPNAME = 336,
    TOK_KEY_OFFSET = 337,
    TOK_KEY_TARGET = 338,
    TOK_KEY_LADDR = 339,
    TOK_KEY_FADDR = 340,
    TOK_KEY_LPORT = 341,
    TOK_KEY_FPORT = 342,
    TOK_KEY_BUS = 343,
    TOK_KEY_PATH = 344,
    TOK_KEY_INTERFACE = 345,
    TOK_KEY_MEMBER = 346,
    TOK_KEY_SIGNAL = 347,
    TOK_KEY_FSTYPE = 348,
    TOK_KEY_FLAGS = 349,
    TOK_KEY_SRCNAME = 350,
    TOK_KEY_CLASS = 351,
    TOK_SOCKLOGD_KERNEL = 352,
    TOK_SYSLOG_KERNEL = 353,
    TOK_SYSLOG_USER = 354
  };
#endif
/* Tokens.  */
#define TOK_DIGITS 258
#define TOK_TYPE_UNKNOWN 259
#define TOK_QUOTED_STRING 260
#define TOK_ID 261
#define TOK_MODE 262
#define TOK_DMESG_STAMP 263
#define TOK_AUDIT_DIGITS 264
#define TOK_DATE_MONTH 265
#define TOK_DATE 266
#define TOK_TIME 267
#define TOK_HEXSTRING 268
#define TOK_TYPE_OTHER 269
#define TOK_MSG_REST 270
#define TOK_IP_ADDR 271
#define TOK_EQUALS 272
#define TOK_COLON 273
#define TOK_MINUS 274
#define TOK_OPEN_PAREN 275
#define TOK_CLOSE_PAREN 276
#define TOK_PERIOD 277
#define TOK_QUESTION_MARK 278
#define TOK_SINGLE_QUOTE 279
#define TOK_TYPE_REJECT 280
#define TOK_TYPE_AUDIT 281
#define TOK_TYPE_COMPLAIN 282
#define TOK_TYPE_HINT 283
#define TOK_TYPE_STATUS 284
#define TOK_TYPE_ERROR 285
#define TOK_TYPE_AA_REJECT 286
#define TOK_TYPE_AA_AUDIT 287
#define TOK_TYPE_AA_COMPLAIN 288
#define TOK_TYPE_AA_HINT 289
#define TOK_TYPE_AA_STATUS 290
#define TOK_TYPE_AA_ERROR 291
#define TOK_TYPE_LSM_AVC 292
#define TOK_TYPE_USER_AVC 293
#define TOK_KEY_APPARMOR 294
#define TOK_KEY_TYPE 295
#define TOK_KEY_MSG 296
#define TOK_KEY_OPERATION 297
#define TOK_KEY_NAME 298
#define TOK_KEY_NAME2 299
#define TOK_KEY_MASK 300
#define TOK_KEY_DENIED_MASK 301
#define TOK_KEY_REQUESTED_MASK 302
#define TOK_KEY_ATTRIBUTE 303
#define TOK_KEY_TASK 304
#define TOK_KEY_PARENT 305
#define TOK_KEY_MAGIC_TOKEN 306
#define TOK_KEY_INFO 307
#define TOK_KEY_PEER_INFO 308
#define TOK_KEY_PID 309
#define TOK_KEY_PEER_PID 310
#define TOK_KEY_PROFILE 311
#define TOK_KEY_PEER_PROFILE 312
#define TOK_KEY_LABEL 313
#define TOK_KEY_PEER_LABEL 314
#define TOK_KEY_PEER 315
#define TOK_AUDIT 316
#define TOK_KEY_FAMILY 317
#define TOK_KEY_SOCK_TYPE 318
#define TOK_KEY_PROTOCOL 319
#define TOK_KEY_NAMESPACE 320
#define TOK_KEY_ERROR 321
#define TOK_KEY_FSUID 322
#define TOK_KEY_FSUID_UPPER 323
#define TOK_KEY_OUID 324
#define TOK_KEY_OUID_UPPER 325
#define TOK_KEY_UID 326
#define TOK_KEY_AUID 327
#define TOK_KEY_SAUID 328
#define TOK_KEY_SES 329
#define TOK_KEY_HOSTNAME 330
#define TOK_KEY_ADDR 331
#define TOK_KEY_TERMINAL 332
#define TOK_KEY_EXE 333
#define TOK_KEY_COMM 334
#define TOK_KEY_CAPABILITY 335
#define TOK_KEY_CAPNAME 336
#define TOK_KEY_OFFSET 337
#define TOK_KEY_TARGET 338
#define TOK_KEY_LADDR 339
#define TOK_KEY_FADDR 340
#define TOK_KEY_LPORT 341
#define TOK_KEY_FPORT 342
#define TOK_KEY_BUS 343
#define TOK_KEY_PATH 344
#define TOK_KEY_INTERFACE 345
#define TOK_KEY_MEMBER 346
#define TOK_KEY_SIGNAL 347
#define TOK_KEY_FSTYPE 348
#define TOK_KEY_FLAGS 349
#define TOK_KEY_SRCNAME 350
#define TOK_KEY_CLASS 351
#define TOK_SOCKLOGD_KERNEL 352
#define TOK_SYSLOG_KERNEL 353
#define TOK_SYSLOG_USER 354

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 97 "grammar.y" /* yacc.c:355  */

	char	*t_str;
	long	t_long;

#line 382 "grammar.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int aalogparse_parse (void *scanner);

#endif /* !YY_AALOGPARSE_GRAMMAR_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 398 "grammar.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  18
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   360

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  100
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  28
/* YYNRULES -- Number of rules.  */
#define YYNRULES  115
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  307

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   354

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   203,   203,   204,   205,   206,   209,   211,   212,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   227,   235,
     239,   240,   244,   246,   248,   250,   253,   255,   257,   259,
     261,   267,   270,   273,   276,   279,   282,   293,   295,   299,
     300,   303,   305,   307,   309,   311,   313,   315,   317,   319,
     321,   323,   325,   327,   329,   331,   332,   333,   335,   337,
     339,   341,   343,   345,   347,   349,   351,   353,   355,   357,
     359,   361,   363,   365,   366,   367,   368,   370,   372,   378,
     384,   385,   391,   395,   400,   404,   406,   408,   410,   412,
     414,   416,   418,   420,   423,   425,   427,   430,   435,   440,
     441,   442,   443,   444,   445,   448,   451,   454,   455,   456,
     457,   459,   462,   463,   466,   467
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_DIGITS", "TOK_TYPE_UNKNOWN",
  "TOK_QUOTED_STRING", "TOK_ID", "TOK_MODE", "TOK_DMESG_STAMP",
  "TOK_AUDIT_DIGITS", "TOK_DATE_MONTH", "TOK_DATE", "TOK_TIME",
  "TOK_HEXSTRING", "TOK_TYPE_OTHER", "TOK_MSG_REST", "TOK_IP_ADDR",
  "TOK_EQUALS", "TOK_COLON", "TOK_MINUS", "TOK_OPEN_PAREN",
  "TOK_CLOSE_PAREN", "TOK_PERIOD", "TOK_QUESTION_MARK", "TOK_SINGLE_QUOTE",
  "TOK_TYPE_REJECT", "TOK_TYPE_AUDIT", "TOK_TYPE_COMPLAIN",
  "TOK_TYPE_HINT", "TOK_TYPE_STATUS", "TOK_TYPE_ERROR",
  "TOK_TYPE_AA_REJECT", "TOK_TYPE_AA_AUDIT", "TOK_TYPE_AA_COMPLAIN",
  "TOK_TYPE_AA_HINT", "TOK_TYPE_AA_STATUS", "TOK_TYPE_AA_ERROR",
  "TOK_TYPE_LSM_AVC", "TOK_TYPE_USER_AVC", "TOK_KEY_APPARMOR",
  "TOK_KEY_TYPE", "TOK_KEY_MSG", "TOK_KEY_OPERATION", "TOK_KEY_NAME",
  "TOK_KEY_NAME2", "TOK_KEY_MASK", "TOK_KEY_DENIED_MASK",
  "TOK_KEY_REQUESTED_MASK", "TOK_KEY_ATTRIBUTE", "TOK_KEY_TASK",
  "TOK_KEY_PARENT", "TOK_KEY_MAGIC_TOKEN", "TOK_KEY_INFO",
  "TOK_KEY_PEER_INFO", "TOK_KEY_PID", "TOK_KEY_PEER_PID",
  "TOK_KEY_PROFILE", "TOK_KEY_PEER_PROFILE", "TOK_KEY_LABEL",
  "TOK_KEY_PEER_LABEL", "TOK_KEY_PEER", "TOK_AUDIT", "TOK_KEY_FAMILY",
  "TOK_KEY_SOCK_TYPE", "TOK_KEY_PROTOCOL", "TOK_KEY_NAMESPACE",
  "TOK_KEY_ERROR", "TOK_KEY_FSUID", "TOK_KEY_FSUID_UPPER", "TOK_KEY_OUID",
  "TOK_KEY_OUID_UPPER", "TOK_KEY_UID", "TOK_KEY_AUID", "TOK_KEY_SAUID",
  "TOK_KEY_SES", "TOK_KEY_HOSTNAME", "TOK_KEY_ADDR", "TOK_KEY_TERMINAL",
  "TOK_KEY_EXE", "TOK_KEY_COMM", "TOK_KEY_CAPABILITY", "TOK_KEY_CAPNAME",
  "TOK_KEY_OFFSET", "TOK_KEY_TARGET", "TOK_KEY_LADDR", "TOK_KEY_FADDR",
  "TOK_KEY_LPORT", "TOK_KEY_FPORT", "TOK_KEY_BUS", "TOK_KEY_PATH",
  "TOK_KEY_INTERFACE", "TOK_KEY_MEMBER", "TOK_KEY_SIGNAL",
  "TOK_KEY_FSTYPE", "TOK_KEY_FLAGS", "TOK_KEY_SRCNAME", "TOK_KEY_CLASS",
  "TOK_SOCKLOGD_KERNEL", "TOK_SYSLOG_KERNEL", "TOK_SYSLOG_USER", "$accept",
  "log_message", "audit_type", "type_syntax", "new_syntax", "other_audit",
  "dmesg_type", "syslog_id", "syslog_type", "audit_dispatch", "audit_msg",
  "audit_user_msg_partial_tail", "audit_user_msg_tail", "audit_user_msg",
  "audit_id", "syslog_date", "key_list", "key", "apparmor_event",
  "key_pid", "key_peer_pid", "ignored_pid", "ignored_uid", "ignored_auid",
  "ignored_ses", "key_type", "safe_string", "protocol", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354
};
# endif

#define YYPACT_NINF -150

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-150)))

#define YYTABLE_NINF -108

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      16,   -56,     3,    33,    48,    50,    69,  -150,  -150,  -150,
    -150,   192,    -5,    52,    59,  -150,    15,    12,  -150,  -150,
      57,    58,    70,    71,    76,    77,    78,    81,    91,    92,
      93,    94,    96,    97,    98,    99,   100,   101,   102,   103,
     105,   106,   107,   108,   109,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   192,  -150,  -150,  -150,   -35,  -150,    -6,
      46,  -150,   143,   143,   143,   143,   143,   143,   143,   143,
     143,   144,  -150,  -150,  -150,   139,  -150,    54,   154,   153,
      27,    27,   155,   156,   157,   158,   161,   163,   165,   164,
     167,   172,   183,    27,    27,    27,    27,   184,   185,   188,
      28,    27,    22,   191,   193,   194,   196,   199,    49,    53,
      55,    27,    27,   200,   201,   202,    27,   195,   198,   205,
     206,   207,   210,   211,   212,   204,   213,   214,   215,   216,
    -150,  -150,   192,   -31,   182,    24,   192,    12,    12,   192,
     208,   192,   192,   192,   192,   192,   192,   192,   209,  -150,
     218,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,   219,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,   192,    41,
     192,    12,   221,    46,   192,   192,   192,   192,  -150,   192,
     192,   192,   192,   192,   192,   192,    12,   148,  -150,    46,
     192,   192,  -150,    12,   192,   192,   171,   220,    12,   192,
     192,   236,   239,  -150,   159,   246,   251,   192,   225,  -150,
     272,   240,   283,   305,   239,  -150,   192,  -150,   320,   308,
     274,   328,   347,  -150,   348,   335,   312,   336,   284,  -150,
     353,   340,  -150,  -150,   334,   192,   192
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       5,     0,     0,     0,     0,    38,     0,     0,     1,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,    39,    55,    56,     0,    21,     0,
       0,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     6,     7,     8,     0,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      40,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    17,
       0,    99,   100,   101,   102,   103,   104,    80,    64,    41,
     112,   113,    42,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,   105,   106,    57,    58,    59,    60,    54,
      61,    62,   115,   114,    63,    43,    65,     0,    67,    69,
      68,    70,    71,    73,    72,    74,    76,    75,    77,    78,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    98,    30,     0,
       0,     0,     0,     0,    22,     0,     0,    15,    18,     9,
      10,    11,    12,    13,    14,    16,     0,     0,    66,     0,
      24,     0,   111,     0,    23,    19,     0,     0,     0,    25,
       0,     0,     0,    35,     0,     0,     0,    29,     0,    34,
       0,     0,     0,     0,    26,    27,    28,   107,     0,     0,
       0,     0,     0,   108,     0,     0,     0,     0,   105,   109,
       0,     0,    36,   110,     0,     0,    33
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,  -150,
      17,    83,    84,  -150,   -68,  -150,  -149,   -73,  -150,  -150,
    -150,  -150,  -150,  -150,  -150,   -76,   -93,  -150
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,    92,    93,    94,     8,    79,     9,    10,
      11,   272,   273,   169,    96,    12,    73,    74,   177,    75,
      76,   274,   281,   290,   296,   157,   182,   204
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     150,    77,   153,   238,   158,    13,    14,   244,   183,   154,
     247,   156,   249,   250,   251,   252,   253,   254,   255,    82,
     195,   196,   197,   198,     1,   206,     2,     3,   205,    83,
     239,   202,   180,   203,   154,   214,   216,   218,   219,   220,
     181,   207,   243,   224,   170,    15,    84,    85,    86,    87,
      88,    89,    90,    91,   180,   155,     4,     5,   180,   259,
     180,   170,   181,   151,   152,    16,   181,    17,   181,    18,
      80,    81,   213,    95,    97,    98,   215,   241,   217,   171,
     172,   173,   174,   175,   176,   240,   154,    99,   100,   245,
     246,   260,    78,   101,   102,   103,   264,   265,   104,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   105,   106,
     107,   108,   269,   109,   110,   111,   112,   113,   114,   115,
     116,   277,   117,   118,   119,   120,   121,   286,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   306,   178,   179,   170,
     184,   185,   186,   187,   188,   150,   189,   263,   190,   191,
     267,   150,   192,   261,   150,   193,   150,   150,   150,   150,
     150,   150,   150,   268,     5,   168,   194,   150,   266,   199,
     200,   150,   150,   201,   208,   270,   150,   210,   209,   242,
     276,   211,   212,   221,   150,   223,   222,    19,   227,   228,
     233,   225,   229,   150,   226,   230,   231,   232,   234,   235,
     236,   237,   258,   248,   262,   271,   256,   257,   287,   275,
     280,    20,    21,   150,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   278,    41,    42,    43,    44,    45,    46,
      47,    48,    49,   279,   282,    50,    19,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   288,
      20,    21,   291,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   283,    35,    36,    37,    38,
      39,    40,   289,    41,    42,    43,    44,    45,    46,    47,
      48,    49,   292,   293,    50,   294,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   295,   297,
     298,   299,   300,   301,   302,  -107,   303,   304,   305,   284,
     285
};

static const yytype_uint16 yycheck[] =
{
      73,     6,     8,   152,    80,    61,     3,   156,   101,    40,
     159,    79,   161,   162,   163,   164,   165,   166,   167,     4,
     113,   114,   115,   116,     8,     3,    10,    11,   121,    14,
      61,     3,     5,     5,    40,   128,   129,   130,   131,   132,
      13,    19,    18,   136,    20,    12,    31,    32,    33,    34,
      35,    36,    37,    38,     5,    61,    40,    41,     5,    18,
       5,    20,    13,    98,    99,    17,    13,    17,    13,     0,
      18,    12,    23,    61,    17,    17,    23,   153,    23,    25,
      26,    27,    28,    29,    30,   153,    40,    17,    17,   157,
     158,   240,    97,    17,    17,    17,   245,   246,    17,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    17,    17,
      17,    17,   261,    17,    17,    17,    17,    17,    17,    17,
      17,   270,    17,    17,    17,    17,    17,   276,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,   305,     3,     5,    20,
       5,     5,     5,     5,     3,   238,     3,   243,     3,     5,
      22,   244,     5,   241,   247,     3,   249,   250,   251,   252,
     253,   254,   255,   259,    41,    41,     3,   260,   256,     5,
       5,   264,   265,     5,     3,   263,   269,     3,     5,    17,
     268,     5,     3,     3,   277,     3,     5,    15,     3,     3,
       6,    16,     5,   286,    16,     5,     5,     5,     5,     5,
       5,     5,     3,    15,     3,    54,    17,     9,     3,     9,
      71,    39,    40,   306,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    17,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    24,    18,    73,    15,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    17,
      39,    40,     9,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    72,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    17,     3,    73,    17,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    74,    21,
       3,     3,    17,    41,    18,    71,     3,    17,    24,   276,
     276
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,    10,    11,    40,    41,   101,   102,   106,   108,
     109,   110,   115,    61,     3,    12,    17,    17,     0,    15,
      39,    40,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      73,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,   116,   117,   119,   120,     6,    97,   107,
      18,    12,     4,    14,    31,    32,    33,    34,    35,    36,
      37,    38,   103,   104,   105,    61,   114,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
     117,    98,    99,     8,    40,    61,   114,   125,   125,   110,
     110,   110,   110,   110,   110,   110,   110,   110,    41,   113,
      20,    25,    26,    27,    28,    29,    30,   118,     3,     5,
       5,    13,   126,   126,     5,     5,     5,     5,     3,     3,
       3,     5,     5,     3,     3,   126,   126,   126,   126,     5,
       5,     5,     3,     5,   127,   126,     3,    19,     3,     5,
       3,     5,     3,    23,   126,    23,   126,    23,   126,   126,
     126,     3,     5,     3,   126,    16,    16,     3,     3,     5,
       5,     5,     5,     6,     5,     5,     5,     5,   116,    61,
     114,   125,    17,    18,   116,   114,   114,   116,    15,   116,
     116,   116,   116,   116,   116,   116,    17,     9,     3,    18,
     116,   114,     3,   125,   116,   116,   114,    22,   125,   116,
     114,    54,   111,   112,   121,     9,   114,   116,    17,    24,
      71,   122,    18,    54,   111,   112,   116,     3,    17,    72,
     123,     9,    17,     3,    17,    74,   124,    21,     3,     3,
      17,    41,    18,     3,    17,    24,   116
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   100,   101,   101,   101,   101,   102,   103,   103,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   105,   106,
     107,   107,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   109,   110,   111,   112,   113,   114,   115,   115,   116,
     116,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   118,
     118,   118,   118,   118,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   126,   127,   127
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     6,
       2,     1,     4,     5,     5,     6,     8,     8,     8,     7,
       4,     2,     3,     8,     2,     4,     9,     3,     2,     1,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, void *scanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
{
  YYUSE (yyvaluep);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 5: /* TOK_QUOTED_STRING  */
#line 196 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1462 "grammar.c" /* yacc.c:1257  */
        break;

    case 6: /* TOK_ID  */
#line 196 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1468 "grammar.c" /* yacc.c:1257  */
        break;

    case 7: /* TOK_MODE  */
#line 196 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1474 "grammar.c" /* yacc.c:1257  */
        break;

    case 8: /* TOK_DMESG_STAMP  */
#line 196 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1480 "grammar.c" /* yacc.c:1257  */
        break;

    case 9: /* TOK_AUDIT_DIGITS  */
#line 197 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1486 "grammar.c" /* yacc.c:1257  */
        break;

    case 10: /* TOK_DATE_MONTH  */
#line 197 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1492 "grammar.c" /* yacc.c:1257  */
        break;

    case 11: /* TOK_DATE  */
#line 197 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1498 "grammar.c" /* yacc.c:1257  */
        break;

    case 12: /* TOK_TIME  */
#line 197 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1504 "grammar.c" /* yacc.c:1257  */
        break;

    case 13: /* TOK_HEXSTRING  */
#line 198 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1510 "grammar.c" /* yacc.c:1257  */
        break;

    case 14: /* TOK_TYPE_OTHER  */
#line 198 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1516 "grammar.c" /* yacc.c:1257  */
        break;

    case 15: /* TOK_MSG_REST  */
#line 198 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1522 "grammar.c" /* yacc.c:1257  */
        break;

    case 16: /* TOK_IP_ADDR  */
#line 199 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1528 "grammar.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 211 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1796 "grammar.c" /* yacc.c:1646  */
    break;

  case 9:
#line 216 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 1802 "grammar.c" /* yacc.c:1646  */
    break;

  case 10:
#line 217 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 1808 "grammar.c" /* yacc.c:1646  */
    break;

  case 11:
#line 218 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 1814 "grammar.c" /* yacc.c:1646  */
    break;

  case 12:
#line 219 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 1820 "grammar.c" /* yacc.c:1646  */
    break;

  case 13:
#line 220 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 1826 "grammar.c" /* yacc.c:1646  */
    break;

  case 14:
#line 221 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 1832 "grammar.c" /* yacc.c:1646  */
    break;

  case 15:
#line 222 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[-2].t_long)); }
#line 1838 "grammar.c" /* yacc.c:1646  */
    break;

  case 18:
#line 228 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = (yyvsp[-2].t_str);
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 1848 "grammar.c" /* yacc.c:1646  */
    break;

  case 19:
#line 236 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); }
#line 1854 "grammar.c" /* yacc.c:1646  */
    break;

  case 20:
#line 239 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-1].t_str)); }
#line 1860 "grammar.c" /* yacc.c:1646  */
    break;

  case 21:
#line 240 "grammar.y" /* yacc.c:1646  */
    { }
#line 1866 "grammar.c" /* yacc.c:1646  */
    break;

  case 22:
#line 245 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1872 "grammar.c" /* yacc.c:1646  */
    break;

  case 23:
#line 247 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1878 "grammar.c" /* yacc.c:1646  */
    break;

  case 24:
#line 249 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-2].t_str)); }
#line 1884 "grammar.c" /* yacc.c:1646  */
    break;

  case 25:
#line 251 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-3].t_str)); }
#line 1890 "grammar.c" /* yacc.c:1646  */
    break;

  case 26:
#line 254 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); }
#line 1896 "grammar.c" /* yacc.c:1646  */
    break;

  case 27:
#line 256 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); }
#line 1902 "grammar.c" /* yacc.c:1646  */
    break;

  case 28:
#line 258 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); }
#line 1908 "grammar.c" /* yacc.c:1646  */
    break;

  case 29:
#line 260 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1914 "grammar.c" /* yacc.c:1646  */
    break;

  case 30:
#line 262 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-2].t_str)); }
#line 1920 "grammar.c" /* yacc.c:1646  */
    break;

  case 31:
#line 267 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1926 "grammar.c" /* yacc.c:1646  */
    break;

  case 36:
#line 283 "grammar.y" /* yacc.c:1646  */
    {
		if (!asprintf(&ret_record->audit_id, "%s.%s:%s", (yyvsp[-6].t_str), (yyvsp[-4].t_str), (yyvsp[-2].t_str)))
			yyerror(scanner, YY_("Out of memory"));
		ret_record->epoch = atol((yyvsp[-6].t_str));
		ret_record->audit_sub_id = atoi((yyvsp[-2].t_str));
		free((yyvsp[-6].t_str));
		free((yyvsp[-4].t_str));
		free((yyvsp[-2].t_str));
	}
#line 1940 "grammar.c" /* yacc.c:1646  */
    break;

  case 37:
#line 294 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-2].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1946 "grammar.c" /* yacc.c:1646  */
    break;

  case 38:
#line 296 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-1].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1952 "grammar.c" /* yacc.c:1646  */
    break;

  case 41:
#line 304 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = (yyvsp[0].t_str);}
#line 1958 "grammar.c" /* yacc.c:1646  */
    break;

  case 42:
#line 306 "grammar.y" /* yacc.c:1646  */
    { ret_record->name = (yyvsp[0].t_str);}
#line 1964 "grammar.c" /* yacc.c:1646  */
    break;

  case 43:
#line 308 "grammar.y" /* yacc.c:1646  */
    { ret_record->namespace = (yyvsp[0].t_str);}
#line 1970 "grammar.c" /* yacc.c:1646  */
    break;

  case 44:
#line 310 "grammar.y" /* yacc.c:1646  */
    { ret_record->name2 = (yyvsp[0].t_str);}
#line 1976 "grammar.c" /* yacc.c:1646  */
    break;

  case 45:
#line 312 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1982 "grammar.c" /* yacc.c:1646  */
    break;

  case 46:
#line 314 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1988 "grammar.c" /* yacc.c:1646  */
    break;

  case 47:
#line 316 "grammar.y" /* yacc.c:1646  */
    { ret_record->requested_mask = (yyvsp[0].t_str);}
#line 1994 "grammar.c" /* yacc.c:1646  */
    break;

  case 48:
#line 318 "grammar.y" /* yacc.c:1646  */
    { ret_record->attribute = (yyvsp[0].t_str);}
#line 2000 "grammar.c" /* yacc.c:1646  */
    break;

  case 49:
#line 320 "grammar.y" /* yacc.c:1646  */
    { ret_record->task = (yyvsp[0].t_long);}
#line 2006 "grammar.c" /* yacc.c:1646  */
    break;

  case 50:
#line 322 "grammar.y" /* yacc.c:1646  */
    { ret_record->parent = (yyvsp[0].t_long);}
#line 2012 "grammar.c" /* yacc.c:1646  */
    break;

  case 51:
#line 324 "grammar.y" /* yacc.c:1646  */
    { ret_record->magic_token = (yyvsp[0].t_long);}
#line 2018 "grammar.c" /* yacc.c:1646  */
    break;

  case 52:
#line 326 "grammar.y" /* yacc.c:1646  */
    { ret_record->info = (yyvsp[0].t_str);}
#line 2024 "grammar.c" /* yacc.c:1646  */
    break;

  case 53:
#line 328 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_info = (yyvsp[0].t_str);}
#line 2030 "grammar.c" /* yacc.c:1646  */
    break;

  case 54:
#line 330 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer = (yyvsp[0].t_str);}
#line 2036 "grammar.c" /* yacc.c:1646  */
    break;

  case 57:
#line 334 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 2042 "grammar.c" /* yacc.c:1646  */
    break;

  case 58:
#line 336 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_profile = (yyvsp[0].t_str);}
#line 2048 "grammar.c" /* yacc.c:1646  */
    break;

  case 59:
#line 338 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 2054 "grammar.c" /* yacc.c:1646  */
    break;

  case 60:
#line 340 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_profile = (yyvsp[0].t_str);}
#line 2060 "grammar.c" /* yacc.c:1646  */
    break;

  case 61:
#line 342 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_family = (yyvsp[0].t_str);}
#line 2066 "grammar.c" /* yacc.c:1646  */
    break;

  case 62:
#line 344 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_sock_type = (yyvsp[0].t_str);}
#line 2072 "grammar.c" /* yacc.c:1646  */
    break;

  case 63:
#line 346 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_protocol = (yyvsp[0].t_str);}
#line 2078 "grammar.c" /* yacc.c:1646  */
    break;

  case 64:
#line 348 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long));}
#line 2084 "grammar.c" /* yacc.c:1646  */
    break;

  case 65:
#line 350 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 2090 "grammar.c" /* yacc.c:1646  */
    break;

  case 66:
#line 352 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 2096 "grammar.c" /* yacc.c:1646  */
    break;

  case 67:
#line 354 "grammar.y" /* yacc.c:1646  */
    { ret_record->fsuid = (yyvsp[0].t_long);}
#line 2102 "grammar.c" /* yacc.c:1646  */
    break;

  case 68:
#line 356 "grammar.y" /* yacc.c:1646  */
    { ret_record->ouid = (yyvsp[0].t_long);}
#line 2108 "grammar.c" /* yacc.c:1646  */
    break;

  case 69:
#line 358 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str));}
#line 2114 "grammar.c" /* yacc.c:1646  */
    break;

  case 70:
#line 360 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str));}
#line 2120 "grammar.c" /* yacc.c:1646  */
    break;

  case 71:
#line 362 "grammar.y" /* yacc.c:1646  */
    { /* Ignore - Source audit ID from user AVC messages */ }
#line 2126 "grammar.c" /* yacc.c:1646  */
    break;

  case 72:
#line 364 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - hostname from user AVC messages */ }
#line 2132 "grammar.c" /* yacc.c:1646  */
    break;

  case 76:
#line 369 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - IP address from user AVC messages */ }
#line 2138 "grammar.c" /* yacc.c:1646  */
    break;

  case 77:
#line 371 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - TTY from user AVC messages */ }
#line 2144 "grammar.c" /* yacc.c:1646  */
    break;

  case 78:
#line 373 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 2154 "grammar.c" /* yacc.c:1646  */
    break;

  case 79:
#line 379 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 2164 "grammar.c" /* yacc.c:1646  */
    break;

  case 81:
#line 386 "grammar.y" /* yacc.c:1646  */
    { /* need to reverse map number to string, need to figure out
	   * how to get auto generation of reverse mapping table into
	   * autotools Makefile.  For now just drop assuming capname is
	   * present which it should be with current kernels */
	}
#line 2174 "grammar.c" /* yacc.c:1646  */
    break;

  case 82:
#line 392 "grammar.y" /* yacc.c:1646  */
    { /* capname used to be reported in name */
	  ret_record->name = (yyvsp[0].t_str);
	}
#line 2182 "grammar.c" /* yacc.c:1646  */
    break;

  case 83:
#line 396 "grammar.y" /* yacc.c:1646  */
    { /* offset is used for reporting where an error occurred unpacking
	   * loaded policy.  We can just drop this currently
	   */
	}
#line 2191 "grammar.c" /* yacc.c:1646  */
    break;

  case 84:
#line 401 "grammar.y" /* yacc.c:1646  */
    { /* target was always name2 in the past */
	  ret_record->name2 = (yyvsp[0].t_str);
	}
#line 2199 "grammar.c" /* yacc.c:1646  */
    break;

  case 85:
#line 405 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_addr = (yyvsp[0].t_str);}
#line 2205 "grammar.c" /* yacc.c:1646  */
    break;

  case 86:
#line 407 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_addr = (yyvsp[0].t_str);}
#line 2211 "grammar.c" /* yacc.c:1646  */
    break;

  case 87:
#line 409 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_port = (yyvsp[0].t_long);}
#line 2217 "grammar.c" /* yacc.c:1646  */
    break;

  case 88:
#line 411 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_port = (yyvsp[0].t_long);}
#line 2223 "grammar.c" /* yacc.c:1646  */
    break;

  case 89:
#line 413 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_bus = (yyvsp[0].t_str); }
#line 2229 "grammar.c" /* yacc.c:1646  */
    break;

  case 90:
#line 415 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_path = (yyvsp[0].t_str); }
#line 2235 "grammar.c" /* yacc.c:1646  */
    break;

  case 91:
#line 417 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_interface = (yyvsp[0].t_str); }
#line 2241 "grammar.c" /* yacc.c:1646  */
    break;

  case 92:
#line 419 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_member = (yyvsp[0].t_str); }
#line 2247 "grammar.c" /* yacc.c:1646  */
    break;

  case 93:
#line 421 "grammar.y" /* yacc.c:1646  */
    { ret_record->signal = (yyvsp[0].t_str); }
#line 2253 "grammar.c" /* yacc.c:1646  */
    break;

  case 94:
#line 424 "grammar.y" /* yacc.c:1646  */
    { ret_record->fs_type = (yyvsp[0].t_str); }
#line 2259 "grammar.c" /* yacc.c:1646  */
    break;

  case 95:
#line 426 "grammar.y" /* yacc.c:1646  */
    { ret_record->flags = (yyvsp[0].t_str); }
#line 2265 "grammar.c" /* yacc.c:1646  */
    break;

  case 96:
#line 428 "grammar.y" /* yacc.c:1646  */
    { ret_record->src_name = (yyvsp[0].t_str); }
#line 2271 "grammar.c" /* yacc.c:1646  */
    break;

  case 97:
#line 431 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 2280 "grammar.c" /* yacc.c:1646  */
    break;

  case 98:
#line 436 "grammar.y" /* yacc.c:1646  */
    { ret_record->class = (yyvsp[0].t_str); }
#line 2286 "grammar.c" /* yacc.c:1646  */
    break;

  case 99:
#line 440 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 2292 "grammar.c" /* yacc.c:1646  */
    break;

  case 100:
#line 441 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 2298 "grammar.c" /* yacc.c:1646  */
    break;

  case 101:
#line 442 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 2304 "grammar.c" /* yacc.c:1646  */
    break;

  case 102:
#line 443 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 2310 "grammar.c" /* yacc.c:1646  */
    break;

  case 103:
#line 444 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 2316 "grammar.c" /* yacc.c:1646  */
    break;

  case 104:
#line 445 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 2322 "grammar.c" /* yacc.c:1646  */
    break;

  case 105:
#line 448 "grammar.y" /* yacc.c:1646  */
    { ret_record->pid = (yyvsp[0].t_long); }
#line 2328 "grammar.c" /* yacc.c:1646  */
    break;

  case 106:
#line 451 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_pid = (yyvsp[0].t_long); }
#line 2334 "grammar.c" /* yacc.c:1646  */
    break;

  case 107:
#line 454 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2340 "grammar.c" /* yacc.c:1646  */
    break;

  case 108:
#line 455 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2346 "grammar.c" /* yacc.c:1646  */
    break;

  case 109:
#line 456 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2352 "grammar.c" /* yacc.c:1646  */
    break;

  case 110:
#line 457 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2358 "grammar.c" /* yacc.c:1646  */
    break;

  case 111:
#line 459 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long)); }
#line 2364 "grammar.c" /* yacc.c:1646  */
    break;

  case 115:
#line 468 "grammar.y" /* yacc.c:1646  */
    { /* FIXME: this should probably convert back to a string proto name */
	  (yyval.t_str) = ipproto_to_string((yyvsp[0].t_long));
	}
#line 2372 "grammar.c" /* yacc.c:1646  */
    break;


#line 2376 "grammar.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 472 "grammar.y" /* yacc.c:1906  */


aa_log_record *
_parse_yacc(char *str)
{
	/* yydebug = 1;  */
	YY_BUFFER_STATE lex_buf;
	yyscan_t scanner;

	ret_record = NULL;
	ret_record = malloc(sizeof(aa_log_record));

	_init_log_record(ret_record);

	if (ret_record == NULL)
		return NULL;

#if (YYDEBUG != 0)
	yydebug = 1;
#endif

	aalogparse_lex_init(&scanner);
	lex_buf = aalogparse__scan_string(str, scanner);
	/* Ignore return value to return an AA_RECORD_INVALID event */
	(void)aalogparse_parse(scanner);
	aalogparse__delete_buffer(lex_buf, scanner);
	aalogparse_lex_destroy(scanner);
	return ret_record;
}
